function p = Pos_LS(d,R,A,tau,idx)
    N = size(A,2);
    idxp = idx;
    idxp(idxp(:,1)==0,1) = N+1;
    idxp(idxp(:,2)==0,2) = N+1;
    R_ = zeros(N,9);
    for i = 1:N
        R_(i,:) = reshape(R{i}',1,9);
    end
    R_(N+1,:) = [1 0 0 0 1 0 0 0 1];
    Ri = R_(idxp(:,1),:);
    r1 = Ri(:,1); r2 = Ri(:,2); r3 = Ri(:,3);
    r4 = Ri(:,4); r5 = Ri(:,5); r6 = Ri(:,6);
    r7 = Ri(:,7); r8 = Ri(:,8); r9 = Ri(:,9);
    D = [tau' tau' tau'].*[d(:,1).*r1+d(:,2).*r4+d(:,3).*r7,d(:,1).*r2+d(:,2).*r5+d(:,3).*r8,d(:,1).*r3+d(:,2).*r6+d(:,3).*r9];
    At = repmat(sqrt(tau)',1,N).*A;
    At = sparse(At);
    p = (At'*At)\(A'*D);
end