function [Sm,SmP,SmR,EP,ER,EPS,A] = SE(P,R,d,z,idx,kappa,tau)
m = size(d,1);
Sm = 0;
SmP = 0;
SmR = 0;
EP = zeros(m,1);
ER = zeros(m,1);
EPS = zeros(m,1);
A = zeros(m,1);
for k = 1:m
    i = idx(k,1);
    j = idx(k,2);
    if i==0
        F = norm(R{j}-z{k},'fro');
        w = d(k,:)' - (P(j,:))';
        EPS(k) = (w'*w)/norm(P(j,:))^2;
    elseif j==0
        F = norm(R{i}'-z{k},'fro');
        w = d(k,:)' + R{i}*P(i,:)';
        EPS(k) = (w'*w)/norm(P(i,:))^2;
    else
        F = norm((R{j}*R{i}')-z{k},'fro');
        w = d(k,:)' - R{i}*(P(j,:)-P(i,:))';
        EPS(k) = (w'*w)/norm(P(j,:)-P(i,:))^2;
    end
    A(k) = F;
    EP(k) = (w'*w);
    SmP = SmP + tau(k)*EP(k);
    ER(k) = (F^2);
    SmR = SmR + kappa(k)*ER(k);
end
% mean(A)
% mean(sqrt(EP))
Sm = Sm + SmP + SmR;
